# Class Menu<TMenuItemProps, TMenuProps, TMenuItem>

A set of actions that can be performed by a user.

#### Type Parameters

- TMenuItemProps extends MenuItemProperties = MenuItemProperties
- TMenuProps extends MenuProperties = MenuProperties
- TMenuItem extends MenuItem<TMenuItemProps, TMenuProps> = MenuItem<TMenuItemProps, TMenuProps>

#### Hierarchy (view full)

- EntityBase<TMenuProps>
  - Menu

#####
Index

### Constructors

constructor

### Properties

_handles
_id
_itemType
@eventTypes
factory

### Accessors

failureMode
id
isDestroyed
isInitialized
items
itemType
parentItem
title

### Methods

_getSerializableProperties
_initializableChildCollections
_initializeChildren
_onDestroy
_onInitialize
_postInitialize
_toPropertyDef
assignProperties
assignPropertiesAsync
destroy
finishAssignProperties
getDefault
getDefaults
getSerializableProperties
initialize
toItemUri
toJSON
create

##
Constructors

### constructor

- new Menu<TMenuItemProps, TMenuProps, TMenuItem>(properties?): Menu<TMenuItemProps, TMenuProps, TMenuItem>

- Creates a new instance of menus/Menu!Menu.

  #### Type Parameters

  - TMenuItemProps extends MenuItemProperties = MenuItemProperties
  - TMenuProps extends MenuProperties = MenuProperties
  - TMenuItem extends MenuItem<TMenuItemProps, TMenuProps> = MenuItem<TMenuItemProps, TMenuProps>

  #### Parameters

  - `Optional` properties: TMenuProps

    An object containing initial property values to set.

  #### Returns Menu<TMenuItemProps, TMenuProps, TMenuItem>

  Overrides EntityBase.constructor

##
Properties

### `Protected` `Readonly`_handles

_handles: Handles<unknown, ResourceHandle>

Inherited from EntityBase._handles

### `Protected`_id

_id: string

The unique ID for this entity. Once set, this should never change.

Inherited from EntityBase._id

### `Protected` `Readonly`_itemType

_itemType: string = ItemType.MENU

The item type for this entity when it participates in an App.

Overrides EntityBase._itemType

### @eventTypes

@eventTypes: InitializableBaseEvents

#### Deprecated

Do not directly reference this property. Use EventNames and EventTypes helpers from @arcgis/core/Evented.

Inherited from EntityBase.@eventTypes

### `Static` factory

factory: MenuFactory

The factory that will be used whenever a new menu needs to be created. Applications can supply their own factory to customize menu creation.

##
Accessors

### failureMode

- get failureMode(): FailureMode

- Determines how a parent object should handle initialization failure in this object. The default is "warn".

  - `"error"`: support/InitializeError!InitializeError is thrown.
  - `"warn"`: Message is logged and support/InitializableBase!InitializeWarningEvent is raised.
  - `"ignore"`: support/InitializableBase!InitializeWarningEvent is raised.

  #### Returns FailureMode

  Inherited from EntityBase.failureMode

- set failureMode(value): void

- #### Parameters

  - value: FailureMode

  #### Returns void

  Inherited from EntityBase.failureMode

### id

- get id(): string

- The unique ID for this entity.

  #### Returns string

  Inherited from EntityBase.id

### isDestroyed

- get isDestroyed(): boolean

- See support/InitializableBase!Initializable.isDestroyed.

  #### Returns boolean

  Inherited from EntityBase.isDestroyed

### isInitialized

- get isInitialized(): boolean

- See support/InitializableBase!Initializable.isInitialized.

  #### Returns boolean

  Inherited from EntityBase.isInitialized

### items

- get items(): Collection<TMenuItem>

- The list of items in the menu.

  #### Returns Collection<TMenuItem>

### itemType

- get itemType(): string

- The item type for this entity when it participates in an App.

  #### Returns string

  Inherited from EntityBase.itemType

### parentItem

- get parentItem(): TMenuItem

- The parent menu item of this menu.

  #### Returns TMenuItem

### title

- get title(): string

- A human-readable title for this menu.

  #### Returns string

- set title(title): void

- #### Parameters

  - title: string

  #### Returns void

##
Methods

### `Protected`_getSerializableProperties

- _getSerializableProperties(): PropertyDefs<TMenuProps>

- The property keys and their metadata that are used to implement serializing and deserializing the class instance.

  #### Returns PropertyDefs<TMenuProps>

  Overrides EntityBase._getSerializableProperties

### `Protected`_initializableChildCollections

- _initializableChildCollections(): IterableIterator<Collection<InitializableBase<InitializableBaseProperties>>, any, any>

- Collections of child items to initialize. Items that fail to initialize are removed from the collection.

  #### Returns IterableIterator<Collection<InitializableBase<InitializableBaseProperties>>, any, any>

  Overrides EntityBase._initializableChildCollections

### `Protected`_initializeChildren

- _initializeChildren(): Promise<void>

- Initializes child entities.

  #### Returns Promise<void>

  Inherited from EntityBase._initializeChildren

### `Protected`_onDestroy

- _onDestroy(): Promise<void>

- Called to perform cleanup. Subclasses should override this method rather than destroy() to perform custom cleanup.

  #### Returns Promise<void>

  Inherited from EntityBase._onDestroy

### `Protected`_onInitialize

- _onInitialize(): Promise<void>

- Called to perform initialization of the support/InitializableBase!InitializableBase. Subclasses should override this method rather than initialize() to perform custom initialization.

  #### Returns Promise<void>

  Inherited from EntityBase._onInitialize

### `Protected`_postInitialize

- _postInitialize(): Promise<void>

- Called after normal initialization. Note: Child items are initialized before this is called.

  #### Returns Promise<void>

  Inherited from EntityBase._postInitialize

### `Protected`_toPropertyDef

- _toPropertyDef<T>(def): PropertyDef<T>

- Converts the value to a PropertyDef object.

  #### Type Parameters

  - T

  #### Parameters

  - def: PropertyDefSerializeMode | PropertyDefSerializeMode[] | PropertyDef<T>

    The value to convert.

  #### Returns PropertyDef<T>

  Inherited from EntityBase._toPropertyDef

### assignProperties

- assignProperties(properties): void

- #### Parameters

  - properties: Partial<TMenuProps>

  #### Returns void

  #### Inherit Doc

  Inherited from EntityBase.assignProperties

### assignPropertiesAsync

- assignPropertiesAsync(properties): Promise<void>

- #### Parameters

  - properties: Partial<TMenuProps>

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from EntityBase.assignPropertiesAsync

### destroy

- destroy(): Promise<void>

- A clean-up function that should get called whenever the item is disposed of.

  #### Returns Promise<void>

  Inherited from EntityBase.destroy

### finishAssignProperties

- finishAssignProperties(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from EntityBase.finishAssignProperties

### getDefault

- getDefault<K>(key): TMenuProps[K]

- #### Type Parameters

  - K extends string | number | symbol

  #### Parameters

  - key: K

  #### Returns TMenuProps[K]

  #### Inherit Doc

  Inherited from EntityBase.getDefault

### getDefaults

- getDefaults(): TMenuProps

- #### Returns TMenuProps

  #### Inherit Doc

  Inherited from EntityBase.getDefaults

### getSerializableProperties

- getSerializableProperties(serializeMode?): PropertyDefs<TMenuProps>

- Returns the serializable properties.

  #### Parameters

  - `Optional` serializeMode: SerializeMode

    Optional. If specified, only properties that support the given serialization mode will be returned.

  #### Returns PropertyDefs<TMenuProps>

  Inherited from EntityBase.getSerializableProperties

### initialize

- initialize(): Promise<void>

- Initializes the item.

  #### Returns Promise<void>

  Inherited from EntityBase.initialize

### toItemUri

- toItemUri(): string

- Creates an item:// URI reference to this entity.

  #### Returns string

  Inherited from EntityBase.toItemUri

### toJSON

- toJSON(serializeMode?): TMenuProps

- #### Parameters

  - serializeMode: SerializeMode = "all"

  #### Returns TMenuProps

  #### Inherit Doc

  Inherited from EntityBase.toJSON

### `Static` create

- create<TMenuProps>(properties): Menu<MenuItemProperties, MenuProperties, MenuItem<MenuItemProperties, MenuProperties>>

- Creates the appropriate subclass of menus/Menu!Menu based on the supplied properties. Applications can customize the default creation behavior by supplying a custom factory object (see menus/Menu!Menu.factory).

  #### Type Parameters

  - TMenuProps extends MenuProperties

  #### Parameters

  - properties: TMenuProps

    The menu properties.

  #### Returns Menu<MenuItemProperties, MenuProperties, MenuItem<MenuItemProperties, MenuProperties>>